    Program f07wkfe

!     F07WKF Example Program Text

!     Mark 24 Release. NAG Copyright 2012.

!     .. Use Statements ..
      Use nag_library, Only: dtftri, dtfttr, nag_wp, x04caf
!     .. Implicit None Statement ..
      Implicit None
!     .. Parameters ..
      Integer, Parameter               :: nin = 5, nout = 6
!     .. Local Scalars ..
      Integer                          :: ifail, info, ldf, lena, n
      Character (1)                    :: diag, transr, uplo
!     .. Local Arrays ..
      Real (Kind=nag_wp), Allocatable  :: a(:), f(:,:)
!     .. Executable Statements ..
      Write (nout,*) 'F07WKF Example Program Results'
!     Skip heading in data file
      Read (nin,*)
      Read (nin,*) n, uplo, transr, diag

      lena = n*(n+1)/2
      ldf = n
      Allocate (a(lena),f(ldf,n))

!     Read A from data file
      Read (nin,*) a(1:lena)

!     Compute inverse of A
!     The NAG name equivalent of dtftri is f07wkf
      Call dtftri(transr,uplo,diag,n,a,info)

      Write (nout,*)
      Flush (nout)
      If (info==0) Then

!       Convert inverse to full array form, and print it
!       The NAG name equivalent of dtfttr is f01vgf
        Call dtfttr(transr,uplo,n,a,f,ldf,info)
        ifail = 0
        Call x04caf(uplo,'Nonunit',n,n,f,ldf,'Inverse',ifail)
      Else
        Write (nout,*) 'A is singular'
      End If

    End Program f07wkfe
